(require "mapping")
(provide "extension")

(defpackage "MCVS-EXTENSION"
    (:documentation "Package to load extensions into.")
  (:use "COMMON-LISP")
  (:import-from "COMMON-LISP-USER"
                "*VERSION-CHANGE-HOOK*"
                "*OPERATION-HOOK*"
                "ADD-HOOK" "REMOVE-HOOK"))

(defconstant *mcvs-extension-dir* "HOC-EXT/")

(defun load-extensions ()
  (ignore-errors
    (in-sandbox-root-dir
     (when (directory *mcvs-extension-dir*)
       (chdir *mcvs-extension-dir*)
       (let ((*package* (find-package "MCVS-EXTENSION")))
         (dolist (e (directory "*.lisp"))
           (current-dir-restore
            (handler-case
                (load e)
              (error (condition)
                     (format *error-output*
                             "Loading extension ~A failed with:~%~A"
                             e
                             condition))))))))))
