;;; This source file is part of the Meta-CVS program, 
;;; which is distributed under the GNU license.
;;; Copyright 2002 Kaz Kylheku

(require "mapping")
(provide "forward")

(defun mcvs-forward (cvs-options)
  (in-sandbox-root-dir
   (current-dir-restore 
    (chdir *mcvs-dir*)
    (let ((current-variant
           (ho-version:version-variant
            (read-version-from-file *mcvs-version-name*))))
      (mcvs-update cvs-options
                   (if current-variant
                       `(("r" ,current-variant))
                       '(("A")))
                   nil)))))

(defun mcvs-forward-wrapper (global-options command-options args)
  (declare (ignore command-options))
  (when args
    (error "command takes no arguments."))
  (mcvs-forward global-options))
