(defun test-pathname-file-p ()
  (assert (pathname-file-p (make-pathname :directory '(:absolute "home")
                                          :name "x"
                                          :type "txt")))
  (assert (pathname-file-p (make-pathname :directory '(:absolute "home")
                                          :type "txt")))
  (assert (pathname-file-p (make-pathname :directory '(:absolute "home")
                                          :name "x")))
  (assert
   (not (pathname-file-p (make-pathname :directory '(:absolute "home"))))))

(defun test-pathname-directory-p ()
  (assert
   (not (pathname-directory-p (make-pathname :directory '(:absolute "home")
                                             :name "x"
                                             :type "txt"))))
  (assert
   (not (pathname-directory-p (make-pathname :directory '(:absolute "home")
                                             :type "txt"))))
  (assert
   (not (pathname-directory-p (make-pathname :directory '(:absolute "home")
                                             :name "x"))))
  (assert
   (pathname-directory-p (make-pathname :directory '(:absolute "home")))))

(defun test-pathname-as-file ()
  (assert
   (equalp
    (pathname-as-file (make-pathname :directory '(:absolute "home" "joe")))
    (make-pathname :directory '(:absolute "home") :name "joe")))
  (assert
   (equalp
    (pathname-as-file (make-pathname :directory '(:absolute "home" "joe")
                                     :name "x"
                                     :type "txt"))
    (make-pathname :directory '(:absolute "home" "joe")
                   :name "x"
                   :type "txt"))))

(defun test-add-type-to-pathname ()
  (assert
   (equalp (make-pathname :name "hello.world" :type "txt")
           (add-type-to-pathname
            (make-pathname :name "hello" :type "world")
            "txt")))
  (assert
   (equalp (make-pathname :name "hello" :type "txt")
           (add-type-to-pathname (make-pathname :name "hello")
                              "txt"))))


(defun test-util ()
  (test-read-chars)
  (test-pathname-file-p)
  (test-pathname-directory-p)
  (test-pathname-as-file)
  (test-add-type-to-pathname))
